unit SSImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, dsgnintf;

type
  TSSImage = class(TImage)
  private
    { Private declarations }
    FTransColor     : TColor;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure Paint; override;
  protected
    { Protected declarations }
  public
    { Public declarations }
    OnPicture : boolean;
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property TransparentColor: TColor read FTransColor write FTransColor;
 end;

procedure Register;

implementation

uses
 ssimgfrm;

constructor TSSImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Picture.Bitmap.TransparentMode := tmFixed;
end;

procedure TSSImage.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if (Self.Transparent and (FTransColor = Self.Canvas.Pixels[x,y])) then
    onPicture := false
  else
    onPicture := True;
  inherited MouseMove(Shift,X,Y);
end;

procedure TSSImage.Paint;
begin
  if Transparent then begin
    Picture.Bitmap.TransparentColor := FTransColor;
  end;
  inherited Paint;
end;

procedure Register;
begin
  RegisterComponents('SimonSoft', [TSSImage]);
  RegisterPropertyEditor(TypeInfo(TColor), TSSImage, 'TransparentColor', TTransColorProperty);
end;

end.

